Index: c/src/lib/libbsp/powerpc/ss555/ChangeLog
===================================================================
RCS file: /usr1/CVS/rtems/c/src/lib/libbsp/powerpc/ss555/ChangeLog,v
retrieving revision 1.52
diff -p -u -u -r1.52 ChangeLog
--- c/src/lib/libbsp/powerpc/ss555/ChangeLog	4 Dec 2008 20:29:55 -0000	1.52
+++ c/src/lib/libbsp/powerpc/ss555/ChangeLog	24 Apr 2009 07:09:17 -0000
@@ -1,3 +1,7 @@
+2009-04-23	Chris Johns <chrisj@rtems.org>
+
+	* startup/start.S: Update for boot_card command line change.
+
 2008-12-04	Joel Sherrill <joel.sherrill@oarcorp.com>
 
 	* bsp_specs: Move -e start from *link to *startfile to avoid warning
Index: c/src/lib/libbsp/powerpc/ss555/startup/start.S
===================================================================
RCS file: /usr1/CVS/rtems/c/src/lib/libbsp/powerpc/ss555/startup/start.S,v
retrieving revision 1.4
diff -p -u -u -r1.4 start.S
--- c/src/lib/libbsp/powerpc/ss555/startup/start.S	26 Oct 2004 14:12:06 -0000	1.4
+++ c/src/lib/libbsp/powerpc/ss555/startup/start.S	24 Apr 2009 07:09:17 -0000
@@ -52,6 +52,11 @@
 #include <rtems/asm.h>
 #include <rtems/powerpc/registers.h>
 
+#warning Call to boot_card has changed and needs checking.
+#warning The call is "void boot_card(const char* cmdline);"
+#warning You need to pass a NULL.
+#warning Please check and remove these warnings.
+	
 /*
  *  The initial stack is set to the top of the internal RAM.
  *
@@ -289,10 +294,7 @@ spin:
 	mtmsr	r0
 
 	/* Start system. */
-	lis	r5, environ@ha
-	la	r5,environ@l(r5)	/* environp */
-	li	r4, 0			/* argv */
-	li	r3, 0			/* argc */
+	li	r3, 0			/* command line */
         EXTERN_PROC (boot_card)
         bl       PROC (boot_card)	/* call the first C routine */
 
Index: c/src/lib/libbsp/powerpc/tqm8xx/ChangeLog
===================================================================
RCS file: /usr1/CVS/rtems/c/src/lib/libbsp/powerpc/tqm8xx/ChangeLog,v
retrieving revision 1.26
diff -p -u -u -r1.26 ChangeLog
--- c/src/lib/libbsp/powerpc/tqm8xx/ChangeLog	9 Mar 2009 16:59:57 -0000	1.26
+++ c/src/lib/libbsp/powerpc/tqm8xx/ChangeLog	24 Apr 2009 07:09:17 -0000
@@ -1,3 +1,7 @@
+2009-04-23	Chris Johns <chrisj@rtems.org>
+
+	* startup/start.S: Update for boot_card command line change.
+
 2009-03-09	Sebastian Huber <sebastian.huber@embedded-brains.de>
 
 	* include/bsp.h: Added missing include.
Index: c/src/lib/libbsp/powerpc/tqm8xx/startup/start.S
===================================================================
RCS file: /usr1/CVS/rtems/c/src/lib/libbsp/powerpc/tqm8xx/startup/start.S,v
retrieving revision 1.1
diff -p -u -u -r1.1 start.S
--- c/src/lib/libbsp/powerpc/tqm8xx/startup/start.S	8 Sep 2008 09:55:39 -0000	1.1
+++ c/src/lib/libbsp/powerpc/tqm8xx/startup/start.S	24 Apr 2009 07:09:17 -0000
@@ -24,6 +24,11 @@
 #include <bsp.h>
 #include <mpc8xx.h>
 
+#warning Call to boot_card has changed and needs checking.
+#warning The call is "void boot_card(const char* cmdline);"
+#warning You need to pass a NULL.
+#warning Please check and remove these warnings.
+	
 .extern boot_card
 
 .section ".entry"  
@@ -144,8 +149,6 @@ start_code_in_ram:	
 
         /* Clear argc, argv and envp */
         xor r3, r3, r3
-        xor r4, r4, r4
-        xor r5, r5, r5
 
         bl      SYM (boot_card)  /* Call the first C routine */
 	
Index: c/src/lib/libbsp/powerpc/virtex/ChangeLog
===================================================================
RCS file: /usr1/CVS/rtems/c/src/lib/libbsp/powerpc/virtex/ChangeLog,v
retrieving revision 1.46
diff -p -u -u -r1.46 ChangeLog
--- c/src/lib/libbsp/powerpc/virtex/ChangeLog	4 Dec 2008 20:30:00 -0000	1.46
+++ c/src/lib/libbsp/powerpc/virtex/ChangeLog	24 Apr 2009 07:09:17 -0000
@@ -1,3 +1,7 @@
+2009-04-23	Chris Johns <chrisj@rtems.org>
+
+	* dlentry/dlentry.S: Update for boot_card command line change.
+
 2008-12-04	Joel Sherrill <joel.sherrill@oarcorp.com>
 
 	* bsp_specs: Move -e start from *link to *startfile to avoid warning
Index: c/src/lib/libbsp/powerpc/virtex/dlentry/dlentry.S
===================================================================
RCS file: /usr1/CVS/rtems/c/src/lib/libbsp/powerpc/virtex/dlentry/dlentry.S,v
retrieving revision 1.2
diff -p -u -u -r1.2 dlentry.S
--- c/src/lib/libbsp/powerpc/virtex/dlentry/dlentry.S	22 Jul 2008 05:47:31 -0000	1.2
+++ c/src/lib/libbsp/powerpc/virtex/dlentry/dlentry.S	24 Apr 2009 07:09:17 -0000
@@ -37,6 +37,11 @@
 
 #include <rtems/asm.h>
 
+#warning Call to boot_card has changed and needs checking.
+#warning The call is "void boot_card(const char* cmdline);"
+#warning You need to pass a NULL.
+#warning Please check and remove these errors.
+	
 /*
  *  The virtex ELF link scripts support three special sections:
  *    .entry    The actual entry point
Index: c/src/lib/libbsp/sh/gensh1/ChangeLog
===================================================================
RCS file: /usr1/CVS/rtems/c/src/lib/libbsp/sh/gensh1/ChangeLog,v
retrieving revision 1.115
diff -p -u -u -r1.115 ChangeLog
--- c/src/lib/libbsp/sh/gensh1/ChangeLog	4 Dec 2008 20:31:44 -0000	1.115
+++ c/src/lib/libbsp/sh/gensh1/ChangeLog	24 Apr 2009 07:09:17 -0000
@@ -1,3 +1,7 @@
+2009-04-23	Chris Johns <chrisj@rtems.org>
+
+	* start/start.S: Update for boot_card command line change.
+
 2008-12-04	Joel Sherrill <joel.sherrill@oarcorp.com>
 
 	* bsp_specs: Move -e start from *link to *startfile to avoid warning
Index: c/src/lib/libbsp/sh/gensh1/start/start.S
===================================================================
RCS file: /usr1/CVS/rtems/c/src/lib/libbsp/sh/gensh1/start/start.S,v
retrieving revision 1.6
diff -p -u -u -r1.6 start.S
--- c/src/lib/libbsp/sh/gensh1/start/start.S	16 Apr 2004 21:51:30 -0000	1.6
+++ c/src/lib/libbsp/sh/gensh1/start/start.S	24 Apr 2009 07:09:17 -0000
@@ -21,6 +21,10 @@
 
 #include <rtems/asm.h>
 
+#warning Call to boot_card has changed and needs checking.
+#warning The call is "void boot_card(const char* cmdline);"
+#warning Please check and remove these warnings.
+	
 	BEGIN_CODE
 	PUBLIC(start)
 SYM (start):
@@ -54,10 +58,9 @@ SYM (start):
 	ldc     r0,vbr
 
 	! call the mainline
-	mov #0,r4		! argc
+	mov #0,r4		! command line
 	mov.l main_k,r0
 	jsr @r0
-	mov #0,r5		! argv
 
 	! call exit
 	mov	r0,r4
Index: c/src/lib/libbsp/sh/gensh2/ChangeLog
===================================================================
RCS file: /usr1/CVS/rtems/c/src/lib/libbsp/sh/gensh2/ChangeLog,v
retrieving revision 1.116
diff -p -u -u -r1.116 ChangeLog
--- c/src/lib/libbsp/sh/gensh2/ChangeLog	4 Dec 2008 20:31:45 -0000	1.116
+++ c/src/lib/libbsp/sh/gensh2/ChangeLog	24 Apr 2009 07:09:17 -0000
@@ -1,3 +1,7 @@
+2009-04-23	Chris Johns <chrisj@rtems.org>
+
+	* start/start.S: Update for boot_card command line change.
+
 2008-12-04	Joel Sherrill <joel.sherrill@oarcorp.com>
 
 	* bsp_specs: Move -e start from *link to *startfile to avoid warning
Index: c/src/lib/libbsp/sh/gensh2/start/start.S
===================================================================
RCS file: /usr1/CVS/rtems/c/src/lib/libbsp/sh/gensh2/start/start.S,v
retrieving revision 1.8
diff -p -u -u -r1.8 start.S
--- c/src/lib/libbsp/sh/gensh2/start/start.S	16 Apr 2004 21:51:30 -0000	1.8
+++ c/src/lib/libbsp/sh/gensh2/start/start.S	24 Apr 2009 07:09:17 -0000
@@ -32,6 +32,10 @@
 
 #include <rtems/asm.h>
 
+#warning Call to boot_card has changed and needs checking.
+#warning The call is "void boot_card(const char* cmdline);"
+#warning Please check and remove these warnings.
+	
 	BEGIN_CODE
 	PUBLIC(start)
 
@@ -136,10 +140,10 @@ SYM (start):
 #endif /* ! STANDALONE_EVB */
 
 	! call the mainline
-	mov #0,r4		! argc
+	mov #0,r4		! command line
 	mov.l main_k,r0
 	jsr @r0
-	mov #0,r5		! argv - can place in dead slot
+	nop
 
 	! call exit
 	mov	r0,r4
Index: c/src/lib/libbsp/sh/gensh4/ChangeLog
===================================================================
RCS file: /usr1/CVS/rtems/c/src/lib/libbsp/sh/gensh4/ChangeLog,v
retrieving revision 1.98
diff -p -u -u -r1.98 ChangeLog
--- c/src/lib/libbsp/sh/gensh4/ChangeLog	4 Dec 2008 20:31:46 -0000	1.98
+++ c/src/lib/libbsp/sh/gensh4/ChangeLog	24 Apr 2009 07:09:17 -0000
@@ -1,3 +1,7 @@
+2009-04-23	Chris Johns <chrisj@rtems.org>
+
+	* start/start.S: Update for boot_card command line change.
+
 2008-12-04	Joel Sherrill <joel.sherrill@oarcorp.com>
 
 	* bsp_specs: Move -e start from *link to *startfile to avoid warning
Index: c/src/lib/libbsp/sh/gensh4/start/start.S
===================================================================
RCS file: /usr1/CVS/rtems/c/src/lib/libbsp/sh/gensh4/start/start.S,v
retrieving revision 1.6
diff -p -u -u -r1.6 start.S
--- c/src/lib/libbsp/sh/gensh4/start/start.S	21 Apr 2004 16:01:46 -0000	1.6
+++ c/src/lib/libbsp/sh/gensh4/start/start.S	24 Apr 2009 07:09:17 -0000
@@ -40,6 +40,10 @@
 #include "rtems/score/sh4_regs.h"
 #include "rtems/score/sh7750_regs.h"
 
+#warning Call to boot_card has changed and needs checking.
+#warning The call is "void boot_card(const char* cmdline);"
+#warning Please check and remove these warnings.
+	
         BEGIN_CODE
         PUBLIC(start)
 
@@ -174,7 +178,7 @@ zero_bss:
         mov #0,r4		! argc
         mov.l main_k,r0
         jsr @r0
-        mov #0,r5		! argv - can place in dead slot
+        nop
 
         ! call exit
         mov	r0,r4
Index: c/src/lib/libbsp/sh/shsim/ChangeLog
===================================================================
RCS file: /usr1/CVS/rtems/c/src/lib/libbsp/sh/shsim/ChangeLog,v
retrieving revision 1.119
diff -p -u -u -r1.119 ChangeLog
--- c/src/lib/libbsp/sh/shsim/ChangeLog	4 Dec 2008 20:31:48 -0000	1.119
+++ c/src/lib/libbsp/sh/shsim/ChangeLog	24 Apr 2009 07:09:17 -0000
@@ -1,3 +1,7 @@
+2009-04-23	Chris Johns <chrisj@rtems.org>
+
+	* start/start.S: Update for boot_card command line change.
+
 2008-12-04	Joel Sherrill <joel.sherrill@oarcorp.com>
 
 	* bsp_specs: Move -e start from *link to *startfile to avoid warning
Index: c/src/lib/libbsp/sh/shsim/start/start.S
===================================================================
RCS file: /usr1/CVS/rtems/c/src/lib/libbsp/sh/shsim/start/start.S,v
retrieving revision 1.7
diff -p -u -u -r1.7 start.S
--- c/src/lib/libbsp/sh/shsim/start/start.S	24 Sep 2008 16:39:44 -0000	1.7
+++ c/src/lib/libbsp/sh/shsim/start/start.S	24 Apr 2009 07:09:17 -0000
@@ -21,6 +21,11 @@
 
 #include <rtems/asm.h>
 
+#warning Call to boot_card has changed and needs checking.
+#warning The call is "void boot_card(const char* cmdline);"
+#warning You need to pass a NULL.
+#warning Please check and remove these warnings.
+	
 	BEGIN_CODE
 	PUBLIC(start)
 SYM (start):
@@ -54,10 +59,10 @@ SYM (start):
 	ldc     r0,vbr
 
 	! call the mainline
-	mov #0,r4		! argc
+	mov #0,r4		! command line
 	mov.l main_k,r0
 	jsr @r0
-	mov #0,r5		! argv
+	
 
 	! call exit
 	mov	r0,r4
Index: c/src/lib/libbsp/shared/ChangeLog
===================================================================
RCS file: /usr1/CVS/rtems/c/src/lib/libbsp/shared/ChangeLog,v
retrieving revision 1.136
diff -p -u -u -r1.136 ChangeLog
--- c/src/lib/libbsp/shared/ChangeLog	10 Mar 2009 17:40:06 -0000	1.136
+++ c/src/lib/libbsp/shared/ChangeLog	24 Apr 2009 07:09:17 -0000
@@ -1,3 +1,9 @@
+2009-04-23	Chris Johns <chrisj@rtems.org>
+
+	* bootcard.c, include/bootcard.h: Remove argc/argv/envp and
+	replace with a single BSP boot command line a BSP can optionally
+	support.
+
 2009-03-10	Eric Norum <norume@aps.anl.gov>
 
 	* bootcard.c: Swap order of RTEMS Workspace and Malloc Heap. This
Index: c/src/lib/libbsp/shared/bootcard.c
===================================================================
RCS file: /usr1/CVS/rtems/c/src/lib/libbsp/shared/bootcard.c,v
retrieving revision 1.42
diff -p -u -u -r1.42 bootcard.c
--- c/src/lib/libbsp/shared/bootcard.c	10 Mar 2009 17:40:06 -0000	1.42
+++ c/src/lib/libbsp/shared/bootcard.c	24 Apr 2009 07:09:17 -0000
@@ -48,9 +48,10 @@
 #include <bsp/bootcard.h>
 
 /*
- *  Since there is a forward reference
+ *  At most a single pointer to the cmdline for those target
+ *  short on memory and not supporting a command line.
  */
-char *rtems_progname;
+const char *bsp_boot_cmdline;
 
 /*
  * Are we using a single heap for the RTEMS Workspace and C Program Heap?
@@ -114,21 +115,15 @@ static rtems_status_code bootcard_bsp_li
  *  as much as possible.
  */
 int boot_card(
-  int    argc, 
-  char **argv, 
-  char **envp
+  const char *cmdline
 )
 {
-  static char            *argv_pointer = NULL;
-  static char            *envp_pointer = NULL;
-  char                  **argv_p = &argv_pointer;
-  char                  **envp_p = &envp_pointer;
-  rtems_interrupt_level   bsp_isr_level;
-  rtems_status_code       sc = RTEMS_SUCCESSFUL;
-  void                   *work_area_start = NULL;
-  intptr_t                work_area_size = 0;
-  void                   *heap_start = NULL;
-  intptr_t                heap_size = 0;
+  rtems_interrupt_level  bsp_isr_level;
+  rtems_status_code      sc = RTEMS_SUCCESSFUL;
+  void                  *work_area_start = NULL;
+  intptr_t               work_area_size = 0;
+  void                  *heap_start = NULL;
+  intptr_t               heap_size = 0;
 
   /*
    * Special case for PowerPC: The interrupt disable mask is stored in SPRG0.
@@ -143,22 +138,7 @@ int boot_card(
    */
   rtems_interrupt_disable( bsp_isr_level );
 
-  /*
-   *  Set things up so we have real pointers for argv and envp.
-   *  If the BSP has passed us something useful, then pass it on.
-   *  Somehow we need to eventually make this available to
-   *  a real main() in user land. :)
-   */
-  if ( argv ) argv_p = argv;
-  if ( envp ) envp_p = envp;
-
-  /*
-   *  Set the program name in case some application cares.
-   */
-  if ((argc > 0) && argv && argv[0])
-    rtems_progname = argv[0];
-  else
-    rtems_progname = "RTEMS";
+  bsp_boot_cmdline = cmdline;
 
   /*
    * Invoke Board Support Package initialization routine written in C.
@@ -169,7 +149,8 @@ int boot_card(
    *  Find out where the block of memory the BSP will use for
    *  the RTEMS Workspace and the C Program Heap is.
    */
-  bsp_get_work_area(&work_area_start, &work_area_size, &heap_start, &heap_size);
+  bsp_get_work_area(&work_area_start, (ssize_t*) &work_area_size,
+                    &heap_start, (ssize_t*) &heap_size);
 
   if ( work_area_size <= Configuration.work_space_size ) {
     printk( "bootcard: Work space too big for work area!\n");
Index: c/src/lib/libbsp/shared/bspinit.c
===================================================================
RCS file: c/src/lib/libbsp/shared/bspinit.c
diff -N c/src/lib/libbsp/shared/bspinit.c
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ c/src/lib/libbsp/shared/bspinit.c	24 Apr 2009 07:09:17 -0000
@@ -0,0 +1,93 @@
+/*
+ *  COPYRIGHT (c) 1989-2009.
+ *  On-Line Applications Research Corporation (OAR).
+ *
+ *  The license and distribution terms for this file may be
+ *  found in the file LICENSE in this distribution or at
+ *  http://www.rtems.com/license/LICENSE.
+ *
+ *  $Id: bspstart.c,v 1.1 2008/09/16 19:10:15 joel Exp $
+ */
+
+#include <stdlib.h>
+#include <string.h>
+
+#include <bsp.h>
+#include <bsp/bootcard.h>
+
+/*
+ * This routine calls main from a confdefs.h default Init task
+ * set up. The bootcard will provide the task argument as
+ * command line string (ASCIIZ).
+ */
+
+int main (int argc, char* argv[]);
+
+void Init (rtems_task_argument arg)
+{
+  const char* boot_cmdline = *((const char**) arg);
+  char*       cmdline = 0;
+  char*       command;
+  int         argc = 0;
+  char**      argv = NULL;
+  int         result = -124;
+
+  if (boot_cmdline)
+  {
+    cmdline = malloc (strlen (boot_cmdline) + 1);
+  
+    if (cmdline)
+    {
+      strcpy (cmdline, boot_cmdline);
+
+      command = cmdline;
+
+      /*
+       * Break the line up into arguments with "" being ignored.
+       */
+      while (true)
+      {
+        command = strtok (command, " \t\r\n");
+        if (command == NULL)
+          break;
+        argc++;
+        command = '\0';
+      }
+
+      argv = calloc (argc, sizeof (char*));
+
+      if (argv)
+      {
+        int a;
+        
+        command = cmdline;
+        argv[0] = command;
+
+        for (a = 1; a < argc; a++)
+        {
+          command += strlen (command) + 1;
+          argv[a] = command;
+        }
+      }
+      else
+        argc = 0;
+    }
+  }
+  
+#ifdef RTEMS_NETWORKING
+  rtems_bsdnet_initialize_network ();
+#endif
+
+  result = main (argc, argv);
+ 
+  free (argv);
+  free (cmdline);
+
+  exit (result);
+}
+
+/*
+ * By making this a weak alias and a user can provide there own.
+ */
+
+void Init (rtems_task_argument arg) __attribute__ ((weak));
Index: c/src/lib/libbsp/shared/include/bootcard.h
===================================================================
RCS file: /usr1/CVS/rtems/c/src/lib/libbsp/shared/include/bootcard.h,v
retrieving revision 1.5
diff -p -u -u -r1.5 bootcard.h
--- c/src/lib/libbsp/shared/include/bootcard.h	2 Oct 2008 19:13:05 -0000	1.5
+++ c/src/lib/libbsp/shared/include/bootcard.h	24 Apr 2009 07:09:17 -0000
@@ -60,7 +60,7 @@ void bsp_get_work_area(
   ssize_t  *heap_size
 );
 
-int boot_card( int argc, char **argv, char **envp);
+int boot_card( const char *cmdline );
 
 void bsp_libc_init( void *heap_start, size_t heap_size, size_t sbrk_amount);
 
Index: c/src/lib/libbsp/sparc/ChangeLog
===================================================================
RCS file: /usr1/CVS/rtems/c/src/lib/libbsp/sparc/ChangeLog,v
retrieving revision 1.66
diff -p -u -u -r1.66 ChangeLog
--- c/src/lib/libbsp/sparc/ChangeLog	27 Feb 2009 15:33:07 -0000	1.66
+++ c/src/lib/libbsp/sparc/ChangeLog	24 Apr 2009 07:09:17 -0000
@@ -1,3 +1,7 @@
+2009-04-23	Chris Johns <chrisj@rtems.org>
+
+	* shared/start/start.S: Update for boot_card command line change.
+
 2009-02-27	Daniel Hellstrom <daniel@gaisler.com>
 
 	PR 1386/bsps
Index: c/src/lib/libbsp/sparc/shared/start.S
===================================================================
RCS file: /usr1/CVS/rtems/c/src/lib/libbsp/sparc/shared/start.S,v
retrieving revision 1.12
diff -p -u -u -r1.12 start.S
--- c/src/lib/libbsp/sparc/shared/start.S	27 Feb 2009 15:33:08 -0000	1.12
+++ c/src/lib/libbsp/sparc/shared/start.S	24 Apr 2009 07:09:17 -0000
@@ -20,6 +20,11 @@
 #include <rtems/asm.h>
 #include <bspopts.h>
 
+#warning Call to boot_card has changed and needs checking.
+#warning The call is "void boot_card(const char* cmdline);"
+#warning You need to pass a NULL.
+#warning Please check and remove these warnings.
+	
 /*
  *  Unexpected trap will halt the processor by forcing it to error state
  */
@@ -329,9 +334,7 @@ zerobss:
         bleu,a zerobss
         nop
 
-        mov     %0, %o2                 ! environ
-        mov     %0, %o1                 ! argv
-        mov     %0, %o0                 ! argc
+        mov     %0, %o0                 ! command line
         call    SYM(boot_card)
         sub     %sp, 0x60, %sp          ! room for boot_card to save args
         nop
Index: c/src/lib/libbsp/unix/posix/ChangeLog
===================================================================
RCS file: /usr1/CVS/rtems/c/src/lib/libbsp/unix/posix/ChangeLog,v
retrieving revision 1.93
diff -p -u -u -r1.93 ChangeLog
--- c/src/lib/libbsp/unix/posix/ChangeLog	1 Dec 2008 17:30:05 -0000	1.93
+++ c/src/lib/libbsp/unix/posix/ChangeLog	24 Apr 2009 07:09:17 -0000
@@ -1,3 +1,7 @@
+2009-04-23	Chris Johns <chrisj@rtems.org>
+
+	* startup/main.c: Update for boot_card command line change.
+
 2008-12-01	Joel Sherrill <joel.sherrill@OARcorp.com>
 
 	* bsp_specs, startup/bspgetworkarea.c: Links hello again.
Index: c/src/lib/libbsp/unix/posix/startup/main.c
===================================================================
RCS file: /usr1/CVS/rtems/c/src/lib/libbsp/unix/posix/startup/main.c,v
retrieving revision 1.2
diff -p -u -u -r1.2 main.c
--- c/src/lib/libbsp/unix/posix/startup/main.c	24 Jul 2007 20:52:56 -0000	1.2
+++ c/src/lib/libbsp/unix/posix/startup/main.c	24 Apr 2009 07:09:17 -0000
@@ -24,7 +24,7 @@ int main(
   char **argv
 )
 {
-  boot_card();
+  boot_card(0);
 
   return 0;
 }
Index: cpukit/ChangeLog
===================================================================
RCS file: /usr1/CVS/rtems/cpukit/ChangeLog,v
retrieving revision 1.1772
diff -p -u -u -r1.1772 ChangeLog
--- cpukit/ChangeLog	15 Apr 2009 08:36:12 -0000	1.1772
+++ cpukit/ChangeLog	24 Apr 2009 07:09:18 -0000
@@ -1,3 +1,9 @@
+2009-04-23	Chris Johns <chrisj@rtems.org>
+
+	* sapi/include/confdefs.h: Add a prototype for Init with C linkage
+	and define Init task command line arguments if confdefs.h provides
+	an Init entry point.
+
 2009-04-15	Ralf Corsepius <ralf.corsepius@rtems.org>
 
 	* configure.ac: Disable LIBSHELL for unix targets.
Index: cpukit/sapi/include/confdefs.h
===================================================================
RCS file: /usr1/CVS/rtems/cpukit/sapi/include/confdefs.h,v
retrieving revision 1.118
diff -p -u -u -r1.118 confdefs.h
--- cpukit/sapi/include/confdefs.h	5 Jan 2009 20:16:07 -0000	1.118
+++ cpukit/sapi/include/confdefs.h	24 Apr 2009 07:09:18 -0000
@@ -518,7 +518,16 @@ rtems_fs_init_functions_t    rtems_fs_in
 #endif
 
 #ifndef CONFIGURE_INIT_TASK_ENTRY_POINT
+  #ifdef __cplusplus
+  extern "C" {
+  #endif
+    rtems_task Init (rtems_task_argument );
+  #ifdef __cplusplus
+  }
+  #endif
   #define CONFIGURE_INIT_TASK_ENTRY_POINT   Init
+  extern const char* bsp_boot_cmdline;
+  #define CONFIGURE_INIT_TASK_ARGUMENTS     ((rtems_task_argument) &bsp_boot_cmdline)
 #endif
 
 #ifndef CONFIGURE_INIT_TASK_INITIAL_MODES
Index: testsuites/samples/ChangeLog
===================================================================
RCS file: /usr1/CVS/rtems/testsuites/samples/ChangeLog,v
retrieving revision 1.149
diff -p -u -u -r1.149 ChangeLog
--- testsuites/samples/ChangeLog	14 Apr 2009 10:22:53 -0000	1.149
+++ testsuites/samples/ChangeLog	24 Apr 2009 07:09:18 -0000
@@ -1,3 +1,8 @@
+2009-04-23	Chris Johns <chrisj@rtems.org>
+
+	* iostream/system.h: Remove the Init prototype. Provide in
+	confdefs.h.
+
 2009-04-14	Sebastian Huber <Sebastian.Huber@embedded-brains.de>
 
 	* fileio/init.c: Removed obsolete header include.
Index: testsuites/samples/iostream/system.h
===================================================================
RCS file: /usr1/CVS/rtems/testsuites/samples/iostream/system.h,v
retrieving revision 1.4
diff -p -u -u -r1.4 system.h
--- testsuites/samples/iostream/system.h	17 Jun 2008 18:50:30 -0000	1.4
+++ testsuites/samples/iostream/system.h	24 Apr 2009 07:09:18 -0000
@@ -15,12 +15,6 @@
 
 #include <rtems.h>
 
-/* functions */
-
-rtems_task Init(
-  rtems_task_argument argument
-);
-
 /* configuration information */
 
 #include <bsp.h> /* for device driver prototypes */
